#
# spec file for package perl-autobox-Core
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-autobox-Core
Version:        1.33
Release:        1.4
%define cpan_name autobox-Core
Summary:        Provide core functions to autoboxed scalars, arrays and hashes
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/autobox-Core/
Source0:        http://www.cpan.org/authors/id/S/SW/SWALTERS/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Want) >= 0.26
BuildRequires:  perl(autobox) >= 2.71
Requires:       perl(Test::More) >= 0.88
Requires:       perl(Want) >= 0.26
Requires:       perl(autobox) >= 2.71
%{perl_requires}

%description
The autobox module promotes Perl's primitive types (literals (strings and
numbers), scalars, arrays and hashes) into first-class objects. However,
autobox does not provide any methods for these new classes.

autobox::CORE provides a set of methods for these new classes. It includes
almost everything in perlfunc, some things from Scalar::Util and
List::Util, and some Perl 5 versions of methods taken from Perl 6.

With _autobox::Core_ one is able to change this:

        print join(" ", reverse(split(" ", $string)));

to this:

        use autobox::Core;

        $string->split(" ")->reverse->print;

Likewise you can change this:

        my $array_ref = [qw(fish dog cat elephant bird)];

        push @$array_ref, qw(snake lizard giraffe mouse);

to this:

        use autobox::Core;
        my $array_ref = [qw(fish dog cat elephant bird)];

        $array_ref->push( qw(snake lizard giraffe mouse));

_autobox::Core_ makes it easier to avoid parentheses pile ups and messy
dereferencing syntaxes.

_autobox::Core_ is mostly glue. It presents existing functions with a new
interface, while adding few extra. Most of the methods read like 'sub hex {
CORE::hex($_[0]) }'. In addition to built-ins from perlfunc that operate on
hashes, arrays, scalars, and code references, some Perl 6-ish things have
been included, and some keywords like 'foreach' are represented too.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README

%changelog
* Sun Dec 18 2016 coolo@suse.com
- updated to 1.33
  see /usr/share/doc/packages/perl-autobox-Core/Changes
* Tue Jan 26 2016 coolo@suse.com
- updated to 1.32
  see /usr/share/doc/packages/perl-autobox-Core/Changes
* Wed Jan 13 2016 coolo@suse.com
- updated to 1.31
  see /usr/share/doc/packages/perl-autobox-Core/Changes
  1.31 (not yet released)
    Docs
  - Corrected spelling mistake (thanks Gregor Herrmann)
  - Document that strings work as regexen (thanks jarich)
    New Features
  - Call backtick() qx() instead (but keep backtick around) (thanks jarich)
    Incompatible Changes
  - s() now returns the modified string or success/fail depending on context
    Fix
  - m() and nm() were failing to signal failure (thanks grtodd!)
* Thu Oct 22 2015 coolo@suse.com
- updated to 1.30
  see /usr/share/doc/packages/perl-autobox-Core/Changes
  1.30
    New Features
  - first() arguments are now consistent with grep(), so now  you can
    supply single non-ref scalar to it (xenu)
    Incompatible Changes
  - Removed smartmatch from first() and grep(). Now these methods have
    consistent behaviour under all perl versions and their code is much
    cleaner (xenu)
    Docs
  - Fixed typo reported by myfwhite on annocpan (xenu)
* Sun Sep 20 2015 coolo@suse.com
- updated to 1.29
  see /usr/share/doc/packages/perl-autobox-Core/Changes
  1.29
    Fix
  - Suppress smartmatch deprecation warnings in perls >= 5.18 (xenu)
* Tue Apr 14 2015 coolo@suse.com
- initial package $version
  * created by $NAME $VERSION
